#!/usr/bin/env python3

"""
Converts chaos.html into JSON. A sample of the input:

<xxx1><p>Dearest <i>creature</i> in <i>creation</i><br>
<xxx2>Studying English <i>pronunciation</i>,<br>
<xxx3><tt>&nbsp;&nbsp;&nbsp;</tt>I will teach you in my <i>verse</i><br>
<xxx4><tt>&nbsp;&nbsp;&nbsp;</tt>Sounds like <i>corpse</i>, <i>corps</i>, <i>horse</i> and <i>worse</i>.</p>

A hand-formatted portion of the output (note that indentation, line breaks,
order of dict entries, etc. don't matter as long as the data matches):

[
    {"stanza": 1,
     "lines": [
          {"lineId": "1-1", "lineNum": 1, "text": "Dearest creature in creation",
           "tokens": ["Dearest", "creature", "in", "creation"],
           "rhymeWord": "creation"},
          {"lineId": "1-2", "lineNum": 2, "text": "Studying English pronunciation,",
           "tokens": ["Studying", "English", "pronunciation", ","],
           "rhymeWord": "pronunciation"},
          ...
     ]},
    {"stanza": 2,
     "lines": [
          {"lineId": "2-1", "lineNum": 1, "text": "I will keep you, Susy, busy,",
           "tokens": ["I", "will", "keep", "you", ",", "Susy", ",", "busy", ","],
           "rhymeWord": "busy"},
          ...
     ]},
     ...
]
"""

import json, re
from nltk import word_tokenize

def hasalpha(token):
    return # TODO: whether any character in the token is a letter

# regex that breaks an HTML line into parts: line number within the stanza, main portion, spacing
LINE_RE = # TODO:

# TODO: read from chaos.html, construct data structure, write to chaos.json
